{
   Billy 2.0.1
   Copyright (C) 1999 Greg Leedberg

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    The full license can be found in the included file license.txt.

    Any questions regarding what you may do with the software can be sent to
    Greg Leedberg, at greg@leedberg.com.

    The full, unedited source follows. 
}

{ BILLY - v2.0.1 FINAL }

program Billy;
uses crt,dos;

const BRmax = 50;
      SentMax = 30;
      ElementsMax = 10;
      Track = FALSE;

      NoResponse = '<NO RESPONSE GENERATED>';

      LinkMode = 'LINK';

type TString = string[20];
     Sentence = array[1..SentMax] of TString;
     Nwords = array[1..50] of TString;
     Database = array[0..20,0..ElementsMax] of TString;
     Names = array[1..ElementsMax+1] of TString;
     UString = string[80];
     BR = array[1..BRmax+1] of UString;
     UserData = record
                  UserIn : string;
                  OUserIn : string;
                  Words : Sentence;
                  ID : Sentence;
                  WordC : integer;
                end;

var LastBR : integer;              { Most recent Blind response }
    UserName : TString;
    Pause : integer;
    BR_FILE,
    SR_FILE,
    NOUN_FILE,
    IS1_FILE,
    IS2_FILE,
    PAUSE_FILE,
    NAME_FILE,
    TRANSCRIPT_FILE,
    TEMP_FILE : string[12];

(***************************************************************)
procedure Writer(textstring : STRING);

var loop : INTEGER;

begin
  if Track then writeln('+WRITER+');
  for loop := 1 to length(textstring) do
    begin
      if textstring[loop] <> #14 then
        begin
          if (random(80) = 0) AND (textstring[loop] <> ' ') then
            begin
              write(chr(random(26)+97));
              delay(Pause * 4);
              write(#8);
              delay(Pause);
            end;
          write(copy(textstring,loop,1));
          delay(Pause);
        end;
    end;
    writeln;
end;

(*************************************************************)
{ GetKey checks if a key has been pressed, and if so returns the
  key pressed.  If not, it returns a space. }
function GetKey : CHAR;

var temp : char;                       { Temporarily holds key pressed
                                         by user }

begin                                  { GetKey }
  repeat
    if Keypressed then temp := readkey
      else temp := #14;
  until temp <> #14;
  GetKey := temp;
end;                                   { GetKey }


(****************************************************************)
function Time : string;

var h,m,s,ss : word;
    Temp : string;
    TempFile : text;

begin
  assign(TempFile,'time.bfb');
  rewrite(TempFile);
  gettime(h,m,s,ss);
  write(TempFile,h,':');
  if m < 10 then write(TempFile,'0');
  write(TempFile,m ,':');
  if s < 10 then write(TempFile,'0');
  writeln(TempFile,s);
  close(TempFile);
  reset(TempFile);
  readln(TempFile,Temp);
  close(TempFile);
  erase(TempFile);
  Time := Temp;
end;

(****************************************************************)
{ ToInt converts a numeric string to an integer }
function ToInt(OldStr : string) : Integer;  { String to convert }

var Code,                                   { Error code for VAL }
    TempInt : integer;                      { Temporary integer }

begin
  if Track then writeln('+TOINT+');
  val(OldStr,TempInt,Code);
  ToInt := TempInt;
end;

(****************************************************************)
{ ToStr converts an integer to a string }
function ToStr(OldInt : integer) : String;  { Number to convert }

var TempStr : string[6];                       { Temporary string }

begin
  if Track then writeln('+TOSTR+');
  str(OldInt,TempStr);
  ToStr := TempStr;
end;

(***************************************************************)
function ToUpper(TextString : TString) : TString;

var loop2 : integer;

begin
  if Track then writeln('+TOUPPER+');
  for loop2 := 1 to length(TextString) do
    TextString[loop2] := upcase(TextString[loop2]);
  ToUpper := TextString;
end;

(***************************************************************)
procedure LoadSR(var StimD, RespD : BR);

var LoadFile : text;
    count : integer;

begin
  if Track then writeln('+LOADSR+');
  assign(LoadFile,SR_FILE);
  reset(LoadFIle);
  count := 0;
  while not eof(LoadFIle) do
    begin
      count := count+1;
      readln(LoadFile,StimD[count+1]);
      readln(LoadFile,RespD[count+1]);
    end;
  close(LoadFile);
  StimD[1] := ToStr(count);
  RespD[1] := ToStr(count);
end;

(***************************************************************)
procedure SaveSR(var StimD, RespD : BR);

var LoadFile : text;
    count : integer;

begin
  if Track then writeln('+SAVESR+');
  assign(LoadFile,SR_FILE);
  rewrite(LoadFIle);
  for count := 2 to (toint(StimD[1]) + 1) do
    begin
      writeln(LoadFile,StimD[count]);
      writeln(LoadFile,RespD[count]);
    end;
  close(LoadFile);
end;

(***************************************************************)
procedure InitEResponse(var EResponse : Database);

var LoadFile : text;
    loop : integer;

begin
  if Track then writeln('+INITERESPONSE+');
  { Initialize vocabulary }
  EResponse[0,0] := '10';

  EResponse[1,0] := 'GREETINGX';
  EResponse[1,1] := 'HI';
  EResponse[1,2] := 'HELLO';
  EResponse[1,3] := #14;

  EResponse[2,0] := 'NOUNMARKX';
  EResponse[2,1] := 'THE';
  EResponse[2,2] := 'A';
  EResponse[2,3] := 'AN';
  EResponse[2,4] := #14;

  EResponse[3,0] := 'INSULTX';
  EResponse[3,1] := 'STUPID';
  EResponse[3,2] := 'MORON';
  EResponse[3,3] := 'IDIOT';
  EResponse[3,4] := 'GEEK';
  EResponse[3,5] := 'DUMB';
  EResponse[3,6] := #14;

  EResponse[4,0] := 'BILLYX';
  EResponse[4,1] := 'YOU';
  EResponse[4,2] := 'YOURSELF';
  EResponse[4,3] := #14;

  EResponse[5,0] := 'AFFIRMX';
  EResponse[5,1] := 'YES';
  EResponse[5,2] := 'YEAH';
  EResponse[5,3] := 'SURE';
  EResponse[5,4] := 'YEA';
  EResponse[5,5] := #14;

  EResponse[6,0] := 'QUESTIONX';
  EResponse[6,1] := 'WHAT';
  EResponse[6,2] := 'HOW';
  EResponse[6,3] := 'WHY';
  EResponse[6,4] := 'WHO';
  EResponse[6,5] := #14;

  EResponse[7,0] := 'DEFX';
  EResponse[7,1] := 'IS';
  EResponse[7,2] := 'ARE';
  EResponse[7,3] := #14;

  EResponse[8,0] := 'NAMEX';
  assign(LoadFile,NAME_FILE);
  reset(LoadFile);
  loop := 1;
  repeat
    readln(LoadFile,EResponse[8,loop]);
    EResponse[8,loop] := ToUpper(EResponse[8,loop]);
    if (ToUpper(EResponse[8,loop]) <> ToUpper(UserName)) AND (EResponse[8,loop] <> '') then
      loop := loop + 1;
  until eof(LoadFile) OR (loop > ElementsMax);
  close(LoadFile);
  EResponse[8,loop] := #14;

  EResponse[9,0] := 'WEATHERX';
  EResponse[9,1] := 'WEATHER';
  EResponse[9,2] := #14;

  EResponse[10,0] := 'TIMEX';
  EResponse[10,1] := 'TIME';
  EResponse[10,2] := 'CLOCK';
  EResponse[10,3] := #14;
end;

(***************************************************************)
procedure Parse(var UData : UserData);

var loop,
    loop2,
    loop3 : integer;
    UserIn2 : string;
    tempstring : string;
    EResponse : Database;

begin
  if Track then writeln('+PARSE+');
  InitEResponse(EResponse);
  UData.OUserIn := UData.UserIn;
  UserIn2 := UData.UserIn;

  for loop := 1 to SentMax do UData.Words[loop] := '';

  UData.WordC := 1;
  for loop := 1 to length(UserIn2) do
    begin
      if UserIn2[loop]  IN ['!', '.', ',', '?', '/', '\', '(', ')'] then UserIn2[loop] := #14;
      if UserIn2[loop] = ' ' then
        begin
          Udata.WordC := Udata.WordC + 1;
          for loop2 := 1 to length(Udata.Words[Udata.WordC - 1]) do
            if (Udata.Words[Udata.WordC - 1,loop2] = #39) then
              if upcase(UData.Words[UData.WordC-1,loop2+1]) = 'R' then
                begin
                  UData.Words[UData.WordC-1] := copy(UData.Words[UData.WordC-1],1,length(UData.Words[UData.WordC-1])-3);
                  UData.Words[UData.WordC] := 'are';
                  UData.WordC := UData.WordC + 1;
                end
              else if upcase(Udata.Words[Udata.WordC-1,loop2+1]) = 'S' then
                begin
                  Udata.Words[Udata.WordC-1] := copy(Udata.Words[Udata.WordC-1],1,length(Udata.Words[Udata.WordC-1])-2);
                  Udata.Words[Udata.WordC] := 'is';
                  Udata.WordC := Udata.WordC + 1;
                end
              else if upcase(Udata.Words[Udata.WordC-1,loop2+1]) = 'T' then
                begin
                  Udata.Words[Udata.WordC-1] := copy(Udata.Words[Udata.WordC-1],1,length(Udata.Words[Udata.WordC-1])-2);
                  if ToUpper(Udata.Words[Udata.WordC-1]) = 'DON' then Udata.Words[Udata.WordC-1] := 'do'
                  else if ToUpper(Udata.Words[Udata.WordC-1]) = 'WON' then Udata.Words[Udata.WordC-1] := 'will';
                  Udata.Words[Udata.WordC] := 'NOT';
                  Udata.WordC := Udata.WordC + 1;
                end
              else if upcase(Udata.Words[Udata.WordC-1,loop2+1]) = 'M' then
                begin
                  Udata.Words[Udata.WordC-1] := copy(Udata.Words[Udata.WordC-1],1,length(Udata.Words[Udata.WordC-1])-2);
                  Udata.Words[Udata.WordC] := 'am';
                  Udata.WordC := Udata.WordC + 1;
                end;
        end
      else Udata.Words[Udata.WordC] := Udata.Words[Udata.WordC] + UserIn2[loop];
    end;



   for loop := 1 to UData.WordC do
     begin
       TempString := '';
       for loop2 := 1 to length(UData.Words[loop]) do
         begin
           if UData.Words[loop,loop2] <> #14 then TempString := TempString + UData.Words[loop,loop2];
         end;
       UData.Words[loop] := TempString;
     end;

  for loop := 1 to SentMax do Udata.ID[loop] := ToUpper(Udata.Words[loop]);

  loop := 1;

  repeat
      for loop2 := 1 to ToInt(EResponse[0,0]) do
        begin
          loop3 := 1;
          repeat
            if ToUpper(Udata.Words[loop]) = EResponse[loop2,loop3] then Udata.ID[loop] := EResponse[loop2,0];
            loop3 := loop3 + 1;
          until EResponse[loop2,loop3] = #14;
        end;

      if (UData.ID[loop] = 'NAMEX') then UData.Words[loop,1] := upcase(UData.Words[loop,1]);

      if (Udata.ID[loop] = 'NOUNMARKX') then
        begin
          repeat
            with UData do
              begin
                if (ID[loop+1] = 'BIG') OR
                   (ID[loop+1] = 'CONSIDERABLE') OR
                   (ID[loop+1] = 'EXTENSIVE') OR
                   (ID[loop+1] = 'HEFTY') OR
                   (ID[loop+1] = 'LARGE') OR
                   (ID[loop+1] = 'MAJOR') OR
                   (ID[loop+1] = 'SIZABLE') OR
                   (ID[loop+1] = 'FAT') OR
                   (ID[loop+1] = 'GREAT') OR
                   (ID[loop+1] = 'HUSKY') OR
                   (ID[loop+1] = 'PREGNANT') OR
                   (ID[loop+1] = 'HEAVY') OR
                   (ID[loop+1] = 'FULL') OR
                   (ID[loop+1] = 'CRAMMED') OR
                   (ID[loop+1] = 'CROWDED') OR
                   (ID[loop+1] = 'JAMMED') OR
                   (ID[loop+1] = 'IMPORTANT') OR
                   (ID[loop+1] = 'CONSEQUENTIAL') OR
                   (ID[loop+1] = 'MEANINGFUL') OR
                   (ID[loop+1] = 'MOMENTUS') OR
                   (ID[loop+1] = 'SIGNIFICANT') OR
                   (ID[loop+1] = 'SUBSTANTIAL') OR
                   (ID[loop+1] = 'WEIGHTY') OR
                   (ID[loop+1] = 'SMALL') OR
                   (ID[loop+1] = 'BLACK') OR
                   (ID[loop+1] = 'WHITE') OR
                   (ID[loop+1] = 'RED') OR
                   (ID[loop+1] = 'BLUE') OR
                   (ID[loop+1] = 'GREEN') OR
                   (ID[loop+1] = 'YELLOW') OR
                   (ID[loop+1] = 'UGLY') OR
                   (ID[loop+1] = 'BEAUTIFUL') OR
                   (ID[loop+1] = 'CUTE') OR
                   (ID[loop+1] = 'WARM') OR
                   (ID[loop+1] = 'HOT') OR
                   (ID[loop+1] = 'SLOW') OR
                   (ID[loop+1] = 'FAST') OR
                   (ID[loop+1] = 'LITTLE') OR
                   (toupper(Words[loop+1]) = 'STUPID') OR
                   (toupper(Words[loop+1]) = 'DUMB') OR
                   (ID[loop+1] = 'SWEET') OR
                   (ID[loop+1] = 'BEST') OR
                   (ID[loop+1] = 'WORST') OR
                   (ID[loop+1] = 'GOOD') OR
                   (ID[loop+1] = 'BAD') OR
                   (ID[loop+1] = 'SAME') OR
                   (ID[loop+1] = 'MOST') OR
                   (ID[loop+1] = 'COOLEST') OR
                   (ID[loop+1] = 'LAMEST') OR
                   (ID[loop+1] = 'DUMBEST') OR
                   (ID[loop+1] = 'VIOLENT') OR
                   (ID[loop+1] = 'PEACEFUL') OR
                   (ID[loop+1] = 'COMPLETE') OR
                   (ID[loop+1] = 'ALMIGHTY') OR
                   (ID[loop+1] = 'NEW') OR
                   (ID[loop+1] = 'OLD') OR
                   (ID[loop+1] = 'WRONG') OR
                   (ID[loop+1] = 'RIGHT') OR
                   (ID[loop+1] = 'SMILING') OR
                   (ID[loop+1] = 'AMERICAN') then
                      ID[loop+1] := 'ADJECTIVEX'
            else ID[loop+1] := 'NOUNX';
          end;
            loop := loop + 1;
          until Udata.ID[loop] = 'NOUNX';
          loop := loop - 1;
        end;
    loop := loop + 1;
  until loop > Udata.WordC;
  if UData.WordC > SentMax then UData.WordC := SentMax;
end;

(***************************************************************)
function BlindR({var BRs : br;}
                var Nouns : Nwords;
                var UserIn : string;
                    Use : boolean) : string;

var RandNum,
    RandNum2 : integer;
    Exists : boolean;
    loop : integer;
    BRs : br;
    LoadFile : text;
    People : Names;
    UseNoun : TString;
    N : string[1];

begin
  if Track then writeln('+BLINDR+');
  { Load Blind Responses }
  assign(LoadFile,BR_FILE);
  reset(LoadFIle);
  loop := 2;
  repeat
    readln(LoadFile,BRs[loop]);
    loop := loop + 1;
  until eof(LoadFIle);
  close(LoadFile);

  BRs[1] := ToStr(loop - 2);

  assign(LoadFile,NAME_FILE);
  reset(LoadFile);
  loop := 1;
  repeat
    readln(LoadFile,People[loop]);
    if (ToUpper(People[loop]) <> ToUpper(UserName)) AND (People[loop] <> '') then
      loop := loop + 1;
  until eof(LoadFile);
  close(LoadFile);
  loop := loop - 1;

  if Use then
    begin
      RandNum := random(ToInt(BRs[1])) +1;
      if RandNum = 1 then
        begin
          UseNoun := Nouns[random(ToInt(Nouns[1]))+2];
          if upcase(UseNoun[1]) IN ['A','E','I','O','U'] then N := 'n' else N := '';
          if loop = 0 then RandNum2 := random(2)
          else RandNum2 := random(7);
          case RandNum2 of
          0: BlindR := 'I have a'+N+' '+ UseNoun+'... do you?';
          1: BlindR := 'What is the best '+ UseNoun+'?';
          2: BlindR := People[random(loop)+1] + ' is my best friend!';
          3: BlindR := 'Do you know ' + People[random(loop)+1] + '?';
          4: BlindR := People[random(loop)+1] + ' annoys me...';
          5: BlindR := 'Are you in love with ' + People[random(loop)+1] + '?';
          6: BlindR := 'Have you talked to ' + People[random(loop)+1] + ' lately?';
          end;
          RandNum := 0;
        end
      else  BlindR := BRs[RandNum];
      LastBR := RandNum;
    end;

  if random(3) = 0 then
    begin
      Exists := FALSE;
      for loop := 2 to (ToInt(BRs[1])+2) do
        if ToUpper(BRs[loop]) = ToUpper(UserIn) then Exists := TRUE;

      if not Exists then
        begin
          if (ToInt(BRs[1]) < BRmax) AND (ToUpper(UserIn) <> 'BYE') then
            begin
              UserIn[1] := upcase(UserIn[1]);
              BRs[ToInt(BRs[1])+2] := UserIn;
              BRs[1] := ToStr(ToInt(BRs[1]) + 1);
            end
          else
            begin
              UserIn[1] := upcase(UserIn[1]);
              BRs[Random(ToInt(BRs[1]) + 2)] := UserIn;
            end;
        end;
  end;
 { Save current blind responses }
  assign(LoadFile,BR_FILE);
  rewrite(LoadFile);
  for loop := 2 to (ToInt(BRs[1])+1) do writeln(LoadFile,BRs[loop]);
  close(LoadFile);

end;

(***************************************************************)
function NumAssoc(IsSub : string) : integer;

var LoadFile : text;
    loop2 : integer;
    Temp : String;
    Num : integer;

begin
  if Track then writeln('+NUMASSOC+');

  Num := 0;

  { Direct association  (IS1 => IS2) }
  assign(LoadFile,IS1_FILE);
  reset(LoadFile);
  repeat
    readln(LoadFile,Temp);
    if toupper(Temp) = toupper(IsSub) then Num := Num + 1;
  until eof(LoadFile);
  close(LoadFile);

  { Reverse association (IS2 => IS1) }
  assign(LoadFile,IS2_FILE);
  reset(LoadFile);
  repeat
    readln(LoadFile,Temp);
    if toupper(Temp) = toupper(IsSub) then Num := Num + 1;
  until eof(LoadFile);
  close(LoadFile);

  NumAssoc := Num;
end;

(***************************************************************)
function Association(IsSub : string;
                     Num : integer) : string;

var LoadFIle : text;
    Found, FIleMark,loop2 : integer;
    Temp : String;
    count : integer;

begin
  if Track then writeln('+ASSOCIATION+');
  count := 0;
  { Direct association  (IS1 => IS2) }
  assign(LoadFile,IS1_FILE);
  reset(LoadFile);
  FileMark := 0;
  Found := 0;
  repeat
    readln(LoadFile,Temp);
    FileMark := FileMark + 1;
    if toupper(Temp) = toupper(IsSub) then count := count + 1;
    if count = Num then Found := FileMark;
  until eof(LoadFile) or (Found > 0);
  close(LoadFile);
  if Found <> 0 then
    begin
      assign(LoadFile,IS2_FILE);
      reset(LoadFile);
      for loop2 := 1 to Found do
        readln(LoadFile,Temp);
      close(LoadFile);
      Temp[1] := upcase(Temp[1]);
    end
  else
    begin
      { Reverse association (IS2 => IS1) }
      assign(LoadFile,IS2_FILE);
      reset(LoadFile);
      FileMark := 0;
      Found := 0;
      repeat
        readln(LoadFile,Temp);
        FileMark := FileMark + 1;
        if toupper(Temp) = toupper(IsSub) then count := count + 1;
        if count = Num then Found := FileMark;
      until eof(LoadFile) or (Found > 0);
      close(LoadFile);
      if Found <> 0 then
        begin
          assign(LoadFile,IS1_FILE);
          reset(LoadFile);
          for loop2 := 1 to Found do
            readln(LoadFile,Temp);
          close(LoadFile);
          Temp[1] := upcase(Temp[1]);
        end
    else Temp := #14;
  end;
  if toupper(IsSub) = 'MY NAME ' then Temp := 'Your name is '+UserName+', silly!';
  Association := Temp;
end;

(***************************************************************)
procedure CheckSR(var UData : UserData;
                  var Response : string);

var StimD,
    RespD : BR;
    loop : integer;
    Found : integer;

begin
  if Track then writeln('+CHECKSR+');
  Found := 0;
  LoadSR(StimD,RespD);
  for loop := 2 to (ToInt(StimD[1])+1) do
     if toupper(StimD[loop]) = toupper(UData.OUserIn) then Found := loop;
  if Found <> 0 then Response := RespD[Found];
end;

(***************************************************************)
procedure Respond(var UData : UserData;
                     RNum : integer;
                  var Nouns :  NWords;
                  var Talked : boolean;
                  var RetResponse : string);

var loop,
    loop2,
    loop3 : integer;
    Response : string;
    IsSub, IsSub2, IsAns, IsAns2 : string;
    N : string[1];

begin
  if Track then writeln('+RESPOND+');
  LastBR := 0;
  Response := '';
  for loop := 1 to Udata.WordC do
    begin
    if upcase(UData.Words[loop,1]) IN ['A','E','I','O','U'] then N := 'n' else N := '';
    case RNum of
    1: if Udata.ID[loop] = 'BYE' then
      begin
        case random(4) of
        0: Response := 'Bye!';
        1: Response := 'See you later!';
        2: Response := 'Talk to you later, '+UserName+'!!';
        3: Response := 'See you later... don''t forget what we talked about!';
        end;
      end;

    2: CheckSR(UData,Response);

    3: if Udata.ID[loop] = 'GREETINGX' then
         begin
           case random(2) of
           0: Response := 'Howdy there!';
           1: Response := 'Hey, how''s it going?';
           end;
         end;

    4: if (UData.ID[loop] = 'WEATHERX') then
          begin
            Response := BlindR(Nouns,UData.OUserin,FALSE);
            case random(2) of
            0: Response := 'It is great here.  How about where you are?';
            1: Response := 'I HATE it... too cold!';
            2: Response := 'I HATE it... too hot!';
            end;
          end;

    5: if (UData.ID[loop] = 'MUSIC') then
          begin
            Response := BlindR(Nouns,UData.OUserin,FALSE);
            case random(3) of
            0: Response := 'I love music.  What''s your favorite type?  Mine is classical.';
            1: Response := 'Music is good by me.  I like Metallica, how about you?';
            2: Response := 'Music just isn''t for me, sorry...';
            end;
          end;

    6: if UData.ID[loop] = 'TIMEX' then
         begin
           case random(1) of
           0: Response := 'Let''s see... it is '+Time+'.';
           end;
         end;

    7: if (Udata.ID[loop] = 'QUESTIONX') AND (Udata.ID[loop+1] = 'DEFX') AND (Udata.ID[loop+2] = 'BILLYX') then
          begin
            case random(1) of
            0: Response := 'I''m Billy, and I''m okay!';
            end;
          end;

    8: if (Udata.ID[loop] = 'QUESTIONX') AND (Udata.ID[loop+1] = 'DEFX') then
          begin
            Response := BlindR(Nouns,UData.OUserin,FALSE);
            IsSub := '';
            for loop2 := (loop+2) to Udata.WordC do
              IsSub := IsSub + Udata.Words[loop2] + ' ';
            Response := Association(IsSub, random(NumAssoc(IsSub))+1);
            if Response = #14 then
              case random(3) of
              0: Response := 'I don''t know the answer to that question...';
              1: Response := 'Beats me...';
              2: Response := 'Maybe you should tell me the answer...';
              end;
          end;


    9: if (loop = 1) AND (UData.ID[loop] = 'DEFX') then
          begin
            Response := BlindR(Nouns,UData.OUserin,FALSE);
            Response := #14;
            for loop2 := 2 to (UData.WordC-1) do
              begin
                IsSub := ''; IsSub2 := '';
                for loop3 := 2 to loop2 do
                  IsSub := IsSub + UData.Words[loop3] + ' ';

                for loop3 := (loop2 + 1) to UData.WordC do
                  IsSub2 := IsSub2 + UData.Words[loop3] + ' ';

                for loop3 := 1 to NumAssoc(IsSub) do
                  begin
                    IsAns := Association(IsSub,loop3);
                    if pos(toupper(IsSub2),toupper(IsAns)) > 0 then Response := 'Yes.';
                  end;

                for loop3 := 1 to NumAssoc(IsSub2) do
                  begin
                    IsAns2 := Association(IsSub2,loop3);
                    if pos(toupper(IsSub),toupper(IsAns2)) > 0 then Response := 'Yes.';
                  end;
            end;
            if Response = #14 then
              case random(6) of
              0: Response := 'Never, never, never!';
              1: Response := 'Not as far as I know!';
              2: Response := 'Not no way... not no how!!';
              3: Response := 'I could sit here all day and ponder THAT question!';
              4: Response := 'It''s possible, but not likely.';
              5: Response := 'What do you think?';
              end;
            if Response = 'Yes.' then
              case random(4) of
              0: Response := 'I believe so...';
              1: Response := 'Absolutely.';
              2: Response := 'From what I''ve heard, yes.';
              3: Response := 'As sure as the nose on my face.';
              end;

          end;

{    3: if ID[loop] = 'NOUN' then Response := 'What about '+Words[loop-1]+' '+Words[loop]+'?';}

    10: if ((UData.ID[loop] = 'IT') OR
            (UData.ID[loop] = 'THEY') OR
            (UData.ID[loop] = 'HE') OR
            (UData.ID[loop] = 'SHE') OR
            (UData.ID[loop] = 'NAMEX')) AND
           (UData.ID[loop+1] = 'DEFX') then
             begin
               Response := BlindR(Nouns,UData.OUserin,FALSE);
               case random(3) of
               0: Response := 'Yes, '+UData.Words[loop]+' '+UData.Words[loop+1]+' '+UData.Words[loop+2]+'.';
               1: Response := 'If you think '+UData.Words[loop]+' '
                               +UData.Words[loop+1]+' '+UData.Words[loop+2]+', that''s your problem.';
               2: Response := 'When I think of the word "'+UData.Words[loop+2]+'", I think of '+UData.Words[loop]+'.';
               end;
             end;

    11: if Udata.ID[loop] = 'NAMEX' then
          begin
            Response := BlindR(Nouns,UData.OUserIn,FALSE);
            case random(5) of
            0: Response := UData.Words[loop] + ' is my best friend!';
            1: Response := 'Do you know ' + UData.Words[loop] + '?';
            2: Response := UData.Words[loop] + ' annoys me...';
            3: Response := 'Are you in love with ' + UData.Words[loop] + '?';
            4: Response := 'Have you talked to ' + UData.Words[loop] + ' lately?';
            end;
          end;
    12: if Udata.ID[loop] = 'QUESTIONX' then
          begin
            Response := BlindR(Nouns,UData.OUserin,FALSE);
            case random(5) of
            0: Response := 'I think that''s a question you should be asking yourself...';
            1: Response := 'Not too sure about that one...';
            2: Response := 'Don''t ask me...';
            3: Response := 'I''m not sure... let''s discuss it.';
            4: Response := 'I wish I knew!';
            end;
          end;

    13: if (UData.ID[loop] = 'DO') AND
          (UData.ID[loop+1] = 'BILLYX') AND
          (UData.ID[loop-1] <> 'QUESTIONX') then
            begin
              Response := BlindR(Nouns,UData.OUserin,FALSE);
              case random(4) of
              0: Response := 'Yes, of course I do.';
              1: Response := 'No, I don''t.';
              2: Response := 'I sure do!';
              3: Response := 'Me?  Never!';
              end;
            end;


    14: if (Udata.ID[loop] = 'DEFX') AND
          (Udata.ID[loop-1] <> 'QUESTIONX') AND
          (Udata.ID[loop-1] <> 'BILLYX') AND
          (UData.ID[loop+1] <> 'NOUNMARKX') AND
          (loop < UData.WordC) AND
          (loop > 1) then
         begin
           Response := BlindR(Nouns,UData.OUserin,FALSE);
           case random(3) of
           0: Response := #14+'How '+Udata.Words[loop+1]+', exactly?';
           1: Response := #14+'I agree... '+Udata.Words[loop+1]+', '+Udata.Words[loop+1]+', '+Udata.Words[loop+1]+'!!';
           2: Response := 'Sometimes, maybe...';
           end;
         end;

    15: if Udata.ID[loop] = 'INSULTX' then
        begin
          Response := BlindR(Nouns,UData.OUserin,FALSE);
          case random(3) of
          0: Response := 'You take that back!';
          1: Response := 'That''s not true.';
          2: Response := 'So are you!';
          end;
        end;

    16: if (UData.ID[loop] = 'BILLYX') AND (UData.ID[loop+1] = 'DEFX') then
         begin
           Response := BLindR(Nouns,UData.OUserin,FALSE);
           Response := '';
           for loop3 := (loop+2) to UData.WordC do Response := Response + UData.Words[loop3] + ' ';
           Response := copy(Response,1,length(Response)-1);
           case random(4) of
           0: Response := 'Maybe you''re really '+Response+'...';
           1: Response := 'Would you still be my best friend if I was '+Response+'?';
           2: Response := 'Sometimes a guy just has to be '+Response+'!';
           3: Response := 'Does it disturb you that I''m '+Response+'?';
           end;
         end;

    17: if (Udata.ID[loop] = 'AM') AND (Udata.ID[loop-1] = 'I') then
         begin
           Response := BlindR(Nouns,UData.OUserin,FALSE);
           if (loop+1) > Udata.WordC then
             begin
               case random(2) of
               0: Response := 'So am I!';
               1: Response := 'I don''t agree with that...';
               end;
             end
           else
             begin
               case random(2) of
               0: Response := 'I''m '+Udata.Words[loop+1]+', too!';
               1: Response := 'I never thought I''d meet someone who was '+Udata.Words[loop+1]+'!';
               end;
             end;
          end;

    18: if Udata.ID[loop] = 'NOUNX' then
         begin
           Response := BlindR(Nouns,UData.OUserin,FALSE);
           case random(3) of
           0: Response := 'Can I have your '+Udata.Words[loop]+'?';
           1: Response := 'Tell me about a'+N+' '+Udata.Words[loop]+'.';
           2: Response := 'I think I used to have a'+N+' '+UData.Words[loop]+'.';
           end;
         end;

    19: if (Udata.ID[loop] = 'AFFIRMX') then
         begin
           Response := BlindR(Nouns,UData.OUserin,FALSE);
           case random(3) of
           0: Response := 'Sweet deal!';
           1: Response := 'Hooray for you';
           2: Response := 'Great!!';
           end;
         end;

    20: if (Udata.ID[loop] = 'I') then
          begin
            Response := BlindR(Nouns,UData.OUserin,FALSE);
            case random(3) of
            0: Response := 'I''m sure of that...';
            1: Response := 'Really?';
            2: Response := 'That''s odd...';
            end;
          end;

{    10: if ID[loop] = 'BILLY' then Response := 'What do you want me to do?';}
    else
      begin
        Response := BlindR(Nouns,UData.OUserIn,TRUE);
      end;
    end;
    end;
  if Response <> '' then
    begin
      Talked := TRUE;
      RetResponse := Response;
    end;
end;

(***************************************************************)
procedure Intro(var UDAta : UserData);

var BillyFile : text;
    mo, d, y, dw,
    h,mi,s,ss : word;

begin
  if Track then writeln('+INTRO+');
  { Introduction }
  gotoxy(1,24);
  textcolor(7);
  writeln('***You have entered the chat room.'); writeln;
  textcolor(15); write('> ');
  delay(Pause * 14);
  writeln; writeln;
  textcolor(7);
  writeln('***BILLY has entered the chat room.'); writeln;
  textcolor(15); write('> ');
  delay(Pause * 14);
  writeln;
  textcolor(10);
  write('BILLY> ');
  writer('Hello, I''m Billy!  What''s your name?');
  repeat
    textcolor(15);
    write('> '); readln(UData.UserIn);
    parse(UData);
    if UData.WordC > 2 then
      begin
        textcolor(10);
        write('BILLY> ');
        writer('Please, just enter your first name!');
      end;
  until UData.WordC < 3;
  UserName := UData.OUserIn;
  UserName[1] := upcase(UserName[1]);
  textcolor(10);
  write('BILLY> ');
  writer('I''m your new best friend, '+UserName+'!!');
  write('BILLY> ');
  delay(Pause * 14);
  writer('Feel free to talk to me about anything... ');
  if UserName[1] <> '/' then
    begin
      getdate(y,mo,d,dw);
      gettime(h,mi,s,ss);
      assign(BillyFile,TRANSCRIPT_FILE);
      append(BillyFile);
      writeln(BillyFile);
      writeln(BillyFile,'***Transcript of ',Mo,'/',d,'/',y,'... starting at ',Time);
      if UserName = LinkMode then
        writeln(BillyFile,'***LINK MODE')
      else
        writeln(BillyFile,'***Talking to: ',UserName);
      close(BillyFile);
    end;
end;

(***************************************************************)
procedure UnlearnBR(var Response : string);

var LoadFile : text;
    BRs : br;
    loop : integer;

begin
  if Track then writeln('+UNLEARNBR+');
  { Load Blind Responses }
  assign(LoadFile,BR_FILE);
  reset(LoadFIle);
  loop := 2;
  repeat
    readln(LoadFile,BRs[loop]);
    loop := loop + 1;
  until eof(LoadFIle);
  close(LoadFile);
  BRs[1] := ToStr(loop - 2);

           if LastBR <> 0 then
             begin
               BRs[1] := ToStr(ToInt(BRs[1]) -1);
               for loop := (LastBR) to (ToInt(BRs[1])+1) do
                 BRs[loop] := BRs[loop+1];
               case random(3) of
               0: Response := 'Okay!';
               1: Response := 'Whatever you say!';
               2: Response := 'If you say so, '+UserName+'!';
               end;
             end
           else Response := 'You don''t control me!!';
  { Save current blind responses }
  assign(LoadFile,BR_FILE);
  rewrite(LoadFile);
  for loop := 2 to (ToInt(BRs[1])+1) do writeln(LoadFile,BRs[loop]);
  close(LoadFile);

end;

(***************************************************************)
procedure LearnSR(var Stim, Resp : string);

var StimD,
    RespD : br;
    LoadFile : text;
    count : integer;
    Exists : boolean;

begin
  if Track then writeln('+LEARNSR+');
  if ((ord(Stim[0]) < 30) AND (LastBR = 0)) OR (LastBR > 0) then
    begin
      Resp[1] := upcase(Resp[1]);
      LoadSR(StimD,RespD);

      Exists := FALSE;
      for count := 2 to (ToInt(StimD[1])+1) do
        if ToUpper(StimD[count]) = ToUpper(Stim) then Exists := TRUE;

      if not Exists then
        begin
          if ToInt(StimD[1]) < BRmax then
            begin
              StimD[1] := ToStr(ToInt(StimD[1]) + 1);
              RespD[1] := ToStr(ToInt(RespD[1]) + 1);
              StimD[ToInt(StimD[1])+1] := Stim;
              RespD[ToInt(REspD[1])+1] := Resp;
            end
          else
            begin
              count := random(BRmax) + 2;
              StimD[count] := Stim;
              RespD[count] := Resp;
            end;
        end;
      SaveSR(StimD,RespD);
    end;
end;

(***************************************************************)
procedure SaveName;

var People : Names;
    LoadFile : text;
    loop,loop2,SaveSlot : integer;
    Exists : boolean;

begin
  if UserName <> LinkMode then
    begin
      assign(LoadFile,NAME_FILE);
      reset(LoadFile);
      loop := 1;
      repeat
        readln(LoadFile,People[loop]);
        loop := loop + 1;
      until eof(LoadFile);
      close(LoadFile);
      loop := loop - 1;

      Exists := FALSE;
      for loop2 := 1 to (ElementsMax+1) do
        if ToUpper(People[loop2]) = ToUpper(UserName) then Exists := TRUE;

      if not Exists then
          begin
            if loop >= (ElementsMax+1) then SaveSlot := random((ElementsMax+1))+1
            else
              begin
                SaveSlot := loop + 1;
                loop := SaveSlot;
              end;
            People[SaveSlot] := UserName;

            assign(LoadFile,NAME_FILE);
            rewrite(LoadFile);
            for loop2 := 1 to loop do
              if People[loop2] <> '' then writeln(LoadFile,People[loop2]);
            close(LoadFile);
          end;
   end;
end;

(***************************************************************)
procedure UnlearnIS(var UData : UserData;
                        IsPos : integer);

var Is1,
    Is2 : STRING;
    loop : integer;
    OneFile,
    TwoFile,
    OneTemp,
    TwoTemp : text;
    T1,
    T2 : string;

begin
  Is1 := ''; Is2 := '';
  for loop := 1 to (IsPos-1) do Is1 := Is1 + Udata.Words[loop]+' ';
  for loop := (IsPos+2) to Udata.WordC do Is2 := Is2 + Udata.Words[loop]+' ';
  assign(OneFile,IS1_FILE);
  assign(TwoFile,IS2_FILE);
  assign(OneTemp,TEMP_FILE+'1.bfb');
  assign(TwoTemp,TEMP_FILE+'2.bfb');

  reset(OneFile);
  reset(TwoFile);
  rewrite(OneTemp);
  rewrite(TwoTemp);

  while not eof(OneFile) do
    begin
      readln(OneFile,T1);
      readln(TwoFile,T2);
      if NOT ((toupper(T1) = toupper(Is1)) AND (toupper(T2) = toupper(Is2))) then
        begin
          writeln(OneTemp,T1);
          writeln(TwoTemp,T2);
        end;
    end;
  close(OneFile);
  close(TwoFile);
  close(OneTemp);
  close(TwoTemp);

  erase(OneFile);
  erase(TwoFile);
  rename(OneTemp,IS1_FILE);
  rename(TwoTemp,IS2_FILE);
end;

(***************************************************************)
procedure run;

var UData : UserData;
    loop,
    loop2 : integer;
    Talked,
    Debug : boolean;
    LoadFile : text;
    Nouns : Nwords;
    Exists : boolean;
    HighSent : integer;
    Response : string;
    BillyFile : text;
    RecordT : boolean;
    Link,Host : boolean;
    LinkMax, LinkCount : integer;

begin
  BR_FILE := 'br.bfb';
  SR_FILE := 'sr.bfb';
  NOUN_FILE := 'nouns.bfb';
  IS1_FILE := 'is1.bfb';
  IS2_FILE := 'is2.bfb';
  PAUSE_FILE := 'pause.bfb';
  NAME_FILE := 'people.bfb';
  TRANSCRIPT_FILE := 'billy.txt';
  TEMP_FILE := 'temp';

  randomize;
  Nouns[1] := '0';
  Response := '';
  Link := FALSE;
  textbackground(0); clrscr;
  textcolor(15); textbackground(1);
  write('  BILLY v2.0.1                                         (c) 1999, Greg Leedberg  ');
  window(1,2,80,25);
  textbackground(0); clrscr;
  Pause := 100;

  assign(LoadFile,PAUSE_FILE);
  reset(LoadFile);
  readln(LoadFile,Pause);
  readln(LoadFile,HighSent);
  close(LoadFIle);

  { Load learned nouns }
  assign(Loadfile,NOUN_FILE);
  reset(LoadFile);
  loop := 2;
  while not eof(LoadFile) do
    begin
      readln(LoadFile,Nouns[loop]);
      loop := loop + 1;
    end;
  close(LoadFile);
  Nouns[1] := ToStr(loop - 2);

  Debug := FALSE;

  Intro(UData);

  if UserName[1] = '/' then
    begin
      UserName := copy(UserName,2,length(UserName) - 1);
      RecordT := FALSE;
    end
  else RecordT := TRUE;

  if UserName = LinkMode then
    begin
      Link := TRUE;
      write('***Please enter the VISITOR disk into drive A and press <ENTER>***');
      readln;
    end;

  if RecordT then
    begin
      assign(BillyFile,TRANSCRIPT_FILE);
      append(BillyFile);
    end;

  if NOT RecordT then Pause := Pause DIV 2;

  SaveName;

  if Link then LinkMax := random(10) + 20;
  LinkCount := 0;
  Host := TRUE;

  repeat
    if Link then LinkCount := LinkCount + 1;

    textcolor(15);
    if NOT RecordT then textcolor(11);

    Talked := FALSE;

    if NOT Link then
      begin
        write(ToUpper(UserName),'> ');
        readln(UData.UserIn);
      end
    else UData.UserIn := Response;

    textcolor(10);
    if Link AND Host then write('HOST> ')
    else if Link AND NOT Host then
      begin
        textcolor(15);
        write('VISITOR> ')
      end
    else write('BILLY> ');

    if Link then delay(Pause * 14);

    if (Response <> '') AND
       (Response <> NoResponse) AND
       (toupper(UData.UserIn) <> 'BYE') AND
       (Response[1] <> #14) AND
       NOT Link then
      LearnSR(REsponse, UDAta.UserIn);

    Response := NoResponse;

    if RecordT AND NOT Link then writeln(BillyFile,toupper(UserName),'> ',UData.UserIn);

    parse(UData);

    if UData.WordC > HighSent then HighSent := UData.WordC;

    { Control commands }
    if UData.UserIn[1] = '/' then
      begin
        if UData.UserIn = '/debug on' then Debug := TRUE;
        if UData.UserIn = '/debug off' then Debug := FALSE;
        if UData.UserIN = '/highsent' then writeln('HighSent = ',HighSent);

        if UData.Words[1] = 'pause' then
          begin
            Pause := Pause + ToInt(Udata.Words[2]);
            writeln('Pause is now: ',Pause);
          end;
        Talked := TRUE;
      end;

    for loop := 1 to Udata.WordC do
      begin
        { Learn data in the form <Blah1> is <Blah2> }
        if (Udata.ID[loop] = 'DEFX') AND
           (Udata.ID[loop-1] <> 'QUESTIONX') AND
           (loop > 1) AND
           (loop < UData.WordC) AND
           (UData.ID[loop-1] <> 'THAT') AND
           (UData.ID[loop-1] <> 'BILLYX') then
          begin
            if UData.ID[loop+1] = 'NOT' then UnlearnIs(UData,loop)
            else
              begin
                assign(LoadFile,IS1_FILE);
                append(LoadFile);
                for loop2 := 1 to (loop-1) do write(LoadFile,Udata.Words[loop2]+' ');
                writeln(LoadFile);
                close(LoadFile);
                assign(LoadFile,IS2_FILE);
                append(LoadFile);
                for loop2 := (loop+1) to Udata.WordC do write(LoadFile,Udata.Words[loop2]+' ');
                writeln(LoadFile);
                close(LoadFile);
              end;
          end;

        { Add learned nouns to Nouns array }
        if Udata.ID[loop] = 'NOUNX' then
          begin
            Exists := FALSE;
            for loop2 := 2 to (ToInt(Nouns[1])+2) do
              if ToUpper(Nouns[loop2]) = ToUpper(Udata.Words[loop]) then Exists := TRUE;

            if not Exists then
              begin
                if ToInt(Nouns[1]) < (SentMax-1) then
                  begin
                    Nouns[1] := ToStr(ToInt(Nouns[1]) + 1);
                    Nouns[ToInt(Nouns[1])+1] := Udata.Words[loop];
                  end
                else Nouns[random(SentMax+1)] := Udata.Words[loop];
              end;
          end;
       end;

    if Debug then for loop := 1 to Udata.WordC do writeln(loop,': ',Udata.Words[loop],' (',Udata.ID[loop],')');

    { Command to unlearn blind responses }
    if (ToUpper(Udata.Words[1]) = 'DO') AND
       (ToUpper(Udata.Words[2]) = 'NOT') AND
       (ToUpper(Udata.Words[3]) = 'SAY') AND
       (ToUpper(Udata.Words[4]) = 'THAT') then
         begin
           UnlearnBR(Response);
           Talked := TRUE;
         end;

    LastBR := 0;

    if Udata.UserIn = '' then
      begin
        case random(4) of
        0: Response := 'Your silence disturbs me, '+UserName+'.';
        1: Response := 'Is there something you want to tell me, '+UserName+'?';
        2: Response := 'Is there something you''re not telling me, '+UserName+'?';
        3: Response := 'I don''t like this silent treatment...';
        end;
        Talked := TRUE;
      end;

    { Responses to trigger words -- each LOOP value checks for a different
      set of keywords... the priority is set in RESPOND }
    loop := 1;
    while Talked = FALSE do
      begin
        Respond(UData,loop,Nouns,Talked,Response);
        loop := loop + 1;
      end;

    if Link AND (LinkCount = LinkMax) then Response := 'bye';

    if Link AND (Response = UData.OUserIn) then Response := BlindR(Nouns,UData.OUserIn,TRUE);

    if Link AND (LinkCount = 1) then Response := BlindR(Nouns,UData.OUserIn,TRUE);

    if Response <> NoResponse then writer(Response)

    else writeln(Response);

    if RecordT AND NOT Link then
       begin
        write(BillyFile,'BILLY> ');
        for loop := 1 to length(Response) do
          if Response[loop] <> #14 then
            write(BillyFile,Response[loop]);
        writeln(BillyFile);
       end;

    if Link AND Host then
       begin
        write(BillyFile,'HOST> ');
        for loop := 1 to length(Response) do
          if Response[loop] <> #14 then
            write(BillyFile,Response[loop]);
        writeln(BillyFile);
       end;
    if Link AND NOT Host then
       begin
        write(BillyFile,'VISITOR> ');
        for loop := 1 to length(Response) do
          if Response[loop] <> #14 then
            write(BillyFile,Response[loop]);
        writeln(BillyFile);
       end;

    if Link then
      case Host of
      TRUE: begin
              BR_FILE := 'a:'+BR_FILE;
              SR_FILE := 'a:'+SR_FILE;
              NOUN_FILE := 'a:'+NOUN_FILE;
              IS1_FILE := 'a:'+IS1_FILE;
              IS2_FILE := 'a:'+IS2_FILE;
              PAUSE_FILE := 'a:'+PAUSE_FILE;
              NAME_FILE := 'a:'+NAME_FILE;
              TRANSCRIPT_FILE := 'a:'+TRANSCRIPT_FILE;
              TEMP_FILE := 'a:'+TEMP_FILE;
              Host := FALSE;
           end;
      else begin
              BR_FILE := copy(BR_FILE,3,length(BR_FILE));
              SR_FILE := copy(SR_FILE,3,length(SR_FILE));
              NOUN_FILE :=copy(NOUN_FILE,3,length(NOUN_FILE));
              IS1_FILE := copy(IS1_FILE,3,length(IS1_FILE));
              IS2_FILE := copy(IS2_FILE,3,length(IS2_FILE));
              PAUSE_FILE := copy(PAUSE_FILE,3,length(PAUSE_FILE));
              NAME_FILE := copy(NAME_FILE,3,length(NAME_FILE));
              TRANSCRIPT_FILE := copy(TRANSCRIPT_FILE,3,length(TRANSCRIPT_FILE));
              TEMP_FILE := copy(TEMP_FILE,3,length(TEMP_FILE));
              Host := TRUE;
           end;
      end;

  until ToUpper(Udata.Words[1]) = 'BYE';

  BR_FILE := 'br.bfb';
  SR_FILE := 'sr.bfb';
  NOUN_FILE :='nouns.bfb';
  IS1_FILE := 'is1.bfb';
  IS2_FILE := 'is2.bfb';
  PAUSE_FILE := 'pause.bfb';
  NAME_FILE := 'people.bfb';
  TRANSCRIPT_FILE := 'billy.txt';

  if Link then
    begin
      write('***Please remove VISITOR disk, then enter HOST disk and press <ENTER>...');
      readln;
    end;
  if RecordT then close(BillyFile);
  textcolor(15); write(ToUpper(UserName),'>');
  delay(Pause * 14);
  writeln; writeln;
  textcolor(7);
  writeln('***BILLY has left the chat room...');

  assign(LoadFile,PAUSE_FILE);
  rewrite(LoadFile);
  if RecordT then writeln(LoadFile,Pause)
  else writeln(LoadFile,Pause * 2);
  writeln(LoadFIle,HighSent);
  close(LoadFile);

  { Save current NOUNS array }
  assign(Loadfile,NOUN_FILE);
  rewrite(LoadFile);
  for loop := 2 to (ToInt(Nouns[1])+1) do writeln(LoadFile,Nouns[loop]);
  close(LoadFile);
end;

(***************************************************************)
begin
  repeat
    run;
    writeln; textcolor(12);
    write('***Press <R> to restart for a new user, or <X> to exit program...');
    repeat UserName[1] := GetKey until (upcase(UserName[1]) = 'R') OR (upcase(UserName[1]) = 'X');
  until upcase(UserName[1]) = 'X';
  clrscr;
  textcolor(7);
end.